﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.IO;
using System.Threading;
using AtmaHunter.Settings;
using ff14bot;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using Newtonsoft.Json;

namespace AtmaHunter
{
    public class AtmaHunter : IBotPlugin
    {
        #region Necessary Stuff
        private AtmaHunterForm _form;
        public string Author { get { return "Exmortem"; } }
        public Version Version { get { return new Version(1, 0); } }
        public string Name { get { return "AtmaHunter"; } }
        public string Description { get { return "Finishes Atma collection for you."; } }
        public bool WantButton
        {
            get { return true; }
        }
        public string ButtonText
        {
            get { return "AtmaHunter"; }
        }
        public void OnButtonPress()
        {
            if (_form == null || _form.IsDisposed || _form.Disposing)
                _form = new AtmaHunterForm();

            _form.ShowDialog();  
        }
        public bool Equals(IBotPlugin other)
        {
            throw new NotImplementedException();
        }
        #endregion
        public void OnPulse()
        {
            if (BotManager.Current.Name == "Fate Bot")
            {
                ChangeZone();
            }
        }

        List<string> Atmas = new List<string>();
        List<string> Inventory = new List<string>();

        Dictionary<int, string> AtmaDictionary = new Dictionary<int, string>();
        public static AtmaHunterSettings settings = AtmaHunterSettings.instance;

        public void OnInitialize()
        {
            #region Atma List
            Atmas.Add("Atma of the Maiden");
            Atmas.Add("Atma of the Archer");
            Atmas.Add("Atma of the Goat");
            Atmas.Add("Atma of the Scorpion");
            Atmas.Add("Atma of the Bull");
            Atmas.Add("Atma of the Twins");
            Atmas.Add("Atma of the Scales");
            Atmas.Add("Atma of the Water-bearer");
            Atmas.Add("Atma of the Ram");
            Atmas.Add("Atma of the Lion");
            Atmas.Add("Atma of the Fish");
            Atmas.Add("Atma of the Crab");
            #endregion
            #region Atma Dictionary
            AtmaDictionary.Add(1, "Atma of the Maiden");
            AtmaDictionary.Add(2, "Atma of the Scorpion");
            AtmaDictionary.Add(3, "Atma of the Water-bearer");
            AtmaDictionary.Add(4, "Atma of the Goat");
            AtmaDictionary.Add(5, "Atma of the Bull");
            AtmaDictionary.Add(6, "Atma of the Ram");
            AtmaDictionary.Add(7, "Atma of the Twins");
            AtmaDictionary.Add(8, "Atma of the Lion");
            AtmaDictionary.Add(9, "Atma of the Fish");
            AtmaDictionary.Add(10, "Atma of the Archer");
            AtmaDictionary.Add(11, "Atma of the Scales");
            AtmaDictionary.Add(12, "Atma of the Crab");
            AtmaDictionary.Add(13, "Atma of the Maiden");
            AtmaDictionary.Add(14, "Atma of the Scorpion");
            AtmaDictionary.Add(15, "Atma of the Water-bearer");
            AtmaDictionary.Add(16, "Atma of the Goat");
            AtmaDictionary.Add(17, "Atma of the Bull");
            AtmaDictionary.Add(18, "Atma of the Ram");
            AtmaDictionary.Add(19, "Atma of the Twins");
            AtmaDictionary.Add(20, "Atma of the Lion");
            AtmaDictionary.Add(21, "Atma of the Fish");
            AtmaDictionary.Add(22, "Atma of the Archer");
            AtmaDictionary.Add(23, "Atma of the Scales");
            AtmaDictionary.Add(0, "Atma of the Crab");
            #endregion
        }
        public void OnShutdown()
        {

        }
        public void OnEnabled()
        {

        }
        public void OnDisabled()
        {

        }

        #region Atmas
        public void ChangeZone()
        {
            #region Gather By Which You're Missing.
            if (!settings.UseJSTTheory)
            {
                if (NextLocation() == "None")
                {
                    Logging.Write("[Atma Hunter] You have a full set of Atmas.");
                    return;
                }

                if (CurrentLocation(WorldManager.ZoneId) == NextLocation())
                {
                    return;
                }

                TreeRoot.Stop();

                if (Core.Player.IsMounted)
                {
                    Actionmanager.Dismount();
                    Thread.Sleep(1000);
                }

                if (CurrentLocation(WorldManager.ZoneId) != NextLocation())
                {
                    Logging.Write("[Atma Hunter] Moving to " + NextLocation());
                    if (NextLocation() == "The Hawthorne Hut")
                        WorldManager.TeleportById(4);
                    else
                        WorldManager.Teleport(NextLocation());
                    Thread.Sleep(15000);
                    TreeRoot.Start();

                }
            }

            #endregion
            #region JST Time Theory Method
            if (settings.UseJSTTheory)
            {
                if (CurrentLocation(WorldManager.ZoneId) == NextTimeLocation())
                {
                    return;
                }

                TreeRoot.Stop();

                if (Core.Player.IsMounted)
                {
                    Actionmanager.Dismount();
                    Thread.Sleep(1000);
                }

                if (CurrentLocation(WorldManager.ZoneId) != NextTimeLocation())
                {
                    Logging.Write("[Atma Hunter] Current JST time is " + DateTime.UtcNow.AddHours(9).Hour);
                    Logging.Write("[Atma Hunter] Moving to " + NextTimeLocation());

                    if (NextTimeLocation() == "The Hawthorne Hut")
                        WorldManager.TeleportById(4);
                    else
                        WorldManager.Teleport(NextTimeLocation());

                    Thread.Sleep(15000);
                    TreeRoot.Start();

                }
            }

            #endregion
        }
        public string NextTimeLocation()
        {
            string atma = AtmaDictionary[DateTime.UtcNow.AddHours(9).Hour];

            switch (atma)
            {
                case "Atma of the Maiden":
                    return "Bentbranch Meadows";//148;

                case "Atma of the Archer":
                    return "Fallgourd Float"; //154;

                case "Atma of the Goat":
                    return "The Hawthorne Hut";//152;

                case "Atma of the Scorpion":
                    return "Forgotten Springs";//146;

                case "Atma of the Bull":
                    return "Camp Drybone";//145;

                case "Atma of the Twins":
                    return "Horizon";//140;

                case "Atma of the Scales":
                    return "Black Brush Station";//141;

                case "Atma of the Water-bearer":
                    return "Camp Bronze Lake";//139;

                case "Atma of the Ram":
                    return "Summerford Farms";//134;

                case "Atma of the Lion":
                    return "Camp Overlook";//180;

                case "Atma of the Fish":
                    return "Moraby Drydocks";//135;

                case "Atma of the Crab":
                    return "Aleport";//138;

                default:
                    return "None";
            }
        }
        public string NextLocation()
        {
            string atma = null;
            string jstAtma = AtmaDictionary[DateTime.UtcNow.AddHours(9).Hour];

            Inventory.Clear();

            foreach (BagSlot a in InventoryManager.Slots)
            {
                Inventory.Add(a.Name);
            }

            if (!Inventory.Contains(jstAtma))
            {
                return GetLocationName(jstAtma);
            }

            foreach (string a in Atmas)
            {
                if (!Inventory.Contains(a))
                    atma = a;
            }

            return GetLocationName(atma);
        }

        private static string GetLocationName(string atma)
        {
            switch (atma)
            {
                case "Atma of the Maiden":
                    return "Bentbranch Meadows";//148;

                case "Atma of the Archer":
                    return "Fallgourd Float"; //154;

                case "Atma of the Goat":
                    return "The Hawthorne Hut";//152;

                case "Atma of the Scorpion":
                    return "Forgotten Springs";//146;

                case "Atma of the Bull":
                    return "Camp Drybone";//145;

                case "Atma of the Twins":
                    return "Horizon";//140;

                case "Atma of the Scales":
                    return "Black Brush Station";//141;

                case "Atma of the Water-bearer":
                    return "Camp Bronze Lake";//139;

                case "Atma of the Ram":
                    return "Summerford Farms";//134;

                case "Atma of the Lion":
                    return "Camp Overlook";//180;

                case "Atma of the Fish":
                    return "Moraby Drydocks";//135;

                case "Atma of the Crab":
                    return "Aleport";//138;

                default:
                    return "None";
            }
        }
        public string CurrentLocation(uint zoneid)
        {
            switch (zoneid)
            {
                case 148:
                    return "Bentbranch Meadows";//148;

                case 154:
                    return "Fallgourd Float"; //154;

                case 152:
                    return "The Hawthorne Hut";//152;

                case 146:
                    return "Forgotten Springs";//146;

                case 145:
                    return "Camp Drybone";//145;

                case 140:
                    return "Horizon";//140;

                case 141:
                    return "Black Brush Station";//141;

                case 139:
                    return "Camp Bronze Lake";//139;

                case 134:
                    return "Summerford Farms";//134;

                case 180:
                    return "Camp Overlook";//180;

                case 135:
                    return "Moraby Drydocks";//135;

                case 138:
                    return "Aleport";//138;

                default:
                    return "None";
            }
        }

        #endregion
    }
 }

namespace AtmaHunter.Settings
{
    public class AtmaHunterSettings : JsonSettings
    {
        [JsonIgnore]
        private static AtmaHunterSettings _instance;
        public static AtmaHunterSettings instance { get { return _instance ?? (_instance = new AtmaHunterSettings("AtmaHunterSettings")); } }
        public AtmaHunterSettings(string filename) : base(Path.Combine(CharacterSettingsDirectory, "AtmaHunter.json")) { }

        [Setting]
        [DefaultValue(false)]
        public bool UseJSTTheory { get; set; }
    }
}
